if (navigator.requestMIDIAccess) 
{
    debugMessage('Browser supports MIDI!');
}


// request MIDI access
if (navigator.requestMIDIAccess) 
{
    navigator.requestMIDIAccess(
	{
        sysex: true  
    }).then(onMIDISuccess, onMIDIFailure);
} else 
{
    alert("No MIDI support in your browser.");
}

function debugMessage(text)
{
	//debugMessage(text);
}


var msbByte = 0;
var msbCount = 0;

var modePatchPatternSeq = 0;
var modeSingleBank = 0;

var MIDIOutDevice;
var midiAccess;
var portID;


// Get the button, and when the user clicks on it, execute myFunction
document.getElementById("firmwareFile").addEventListener('change', functionSendFirmware, false);



//document.getElementById("checkBoxRequestScreenshot"). = function() {functionRequestScreenShot()};

var patchBuffer;
var patternBuffer;
var sequenceBuffer;
var bankOfPatches = [];
var bankOfPatterns = [];
var bankOfSequences = [];

var screenShotFunctionRefreshId;
var screenShotUpdated = true;
var bigBufferMIDIIn = [];

var rawTransferBuffer = new Uint8Array(LARGEST_BUFFER_LENGTH);


function onLoadInit()
{
	initAppearance();
	
	patchBuffer = new Array(PATCH_LENGTH_BYTES_UNPACKED);
	for (var i = 0; i < BANK_OF_PATCHES_LENGTH; i++)
	{
	     //   QListWidgetItem* item = new QListWidgetItem("1");
	    //ui->listWidgetPatches->addItem(item);
	    bankOfPatches[i] = patchBuffer;
	}
}

// midi functions
function onMIDISuccess(midiAccess) 
{
    // when we get a succesful response, run this code
    //debugMessage('MIDI Access Object', midiAccess);

 // when we get a succesful response, run this code
    midi = midiAccess; // this is our raw MIDI data, inputs, outputs, and sysex status

    var allInputs = midi.inputs.values();
//var inputs2 = midi.inputs;

 // to tell how many entries there are:
    var numberOfMIDIInputs = allInputs.size;

    var index = 0;
    
    
	for ( var input = allInputs.next(); input && !input.done; input = allInputs.next())
	 {
		var deviceName = input.value.name;
		//debugMessage(deviceName);
		var opt = document.createElement("option");
		//opt.text = "MIDI IN: " + deviceName;
		opt.text = deviceName;
		var chooser = document.getElementById("inputportselector");
		chooser.add(opt);
		input.value.onmidimessage = onMIDIMessage;
		if (deviceName.includes("Motas"))
		{
			chooser.selectedIndex = index; 
		}
		index++;
	}

	index = 0;
	var outputs = midi.outputs.values();

	var numberOfMIDIOutputs = outputs.size;

	
	for (var output = outputs.next(); output && !output.done; output = outputs.next()) 
	{
		//debugMessage('MIDI Access Object', output);
		var deviceName = output.value.name;
		//debugMessage(deviceName);
		var opt = document.createElement("option");
	  //	opt.text = "MIDI OUT: " + deviceName;
		opt.text = deviceName;
		opt.value = output.value.id;
		var chooser = document.getElementById("outputportselector");
		chooser.add(opt);
		MIDIOutDevice = midi;
		if (deviceName.includes("Motas"))
		{
			chooser.selectedIndex = index; 
		}
		index++;
	}
}

function onMIDIFailure(e) 
{
    // when we get a failed response, run this code
    debugMessage("No access to MIDI devices or your browser doesn't support WebMIDI API." + e);
    alert("No access to MIDI devices or your browser doesn't support WebMIDI API.");
}



function onMIDIMessage(message) 
{
    data = message.data; // this gives us our [command/channel, note, velocity] data.
   
    //debugMessage('MIDI data', 'received'); // MIDI data [144, 63, 73]


	if (message.data[8] == MIDI_SYSEX_START_TRANSFER)
	{
		bigBufferMIDIIn = [];
	
		//debugMessage('MIDI SysEx', 'start of transfer');
		//debugMessage('MIDI SysEx', message.data);
	}

	var len = bigBufferMIDIIn.length;
	for (i = 0; i < message.data.length; i++)
	{
        bigBufferMIDIIn[len + i] =  message.data[i];
	}


	if (message.data[8] == MIDI_SYSEX_END_TRANSFER)
	{
	
		//debugMessage('MIDI data', 'end transfer received'); // MIDI data [144, 63, 73]
		//debugMessage('MIDI SysEx', 'end of transfer');
		var type = message.data[7];
		//debugMessage('MIDI buffer', bigBufferMIDIIn);
		processMIDIdata( type,  bigBufferMIDIIn);
	}
}






/* myFunction toggles between adding and removing the show class, which is used to hide and show the dropdown content */
function functionSendFirmware(e) 
{
	  
    debugMessage('MIDI data', 'send update');

	//var selectedFile = document.getElementById('firmwareFile').files[0];
	//debugMessage('file data',selectedFile.size );

	 var selectedFile = e.target.files[0];
	 if (!selectedFile) 
	 {
	    return;
	 }
	    
	var reader = new FileReader();

	reader.readAsArrayBuffer(selectedFile);
	reader.onload = function readSuccess(e)
	{
		var rawDataBuffer = reader.result;
		   
		//debugMessage('file data','file opened' );
		var id = getMIDIOutId();
  		debugMessage('MIDI id', id);
		sendDataOverMIDI(id,rawDataBuffer,rawDataBuffer.byteLength, MIDI_SYSEX_FIRMWARE, 0, 0, 0);
	}
}

function getMIDIOutId()
{
	var e = document.getElementById("outputportselector");
	var id = e.options[e.selectedIndex].value;
	return id;
}

function sendMIDI(id, array, j, lastPacket)
{
	//debugMessage( " array: " + array);
	
	var output = MIDIOutDevice.outputs.get(id);
	output.send(array);
	//var e = document.getElementById;

	
	
	
	var done = Math.trunc(( 100 * j) / lastPacket);
	if (done < 99)
		document.getElementById("progress").innerHTML = Math.trunc(( 100 * j) / lastPacket) + "% done";
	else
		document.getElementById("progress").innerHTML = " ";
	
	//debugMessage( " j: " + j);
	
	
	

}
function sendDataOverMIDI(id,  buffer,  fileLength,  type,  msg0,  msg1,  msg2)
{
	debugMessage('send data of length', fileLength);
	var view = new DataView(buffer);
    for (var i = 0; i < fileLength; i++)
    {
        if (view.getUint8(i) > 0x7F)
        {
			debugMessage('data out-of-range', buffer[i]);
			window.alert("data out-of-range! Have you selected the correct file?");
            //qDebug() << "ERROR IN FILE  - value greater than 0x7F!";
            //QMessageBox::warning(this, "Error", "ERROR IN FILE  - value greater than 0x7F!");
            return;
        }
    }
    //qDebug() << "MidiSettingsDialog: sending firmware";
    var packetSize = 64;
    var lastPacket = 1 + Math.trunc(fileLength / packetSize);
    //ui->progressBarMidi->setMinimum(0);
    //ui->progressBarMidi->setMaximum(lastPacket);
    //quint32 firmwareBytesSent = 0;
    //QThread* th = new QThread;
	var modelNum = document.getElementById("motasModel").value;
	var channel = document.getElementById("midiChannel").value - 1;
	debugMessage('motas model, channel', modelNum + " : " + channel);
    for (var j = 0; j < lastPacket; j++)
    {
		//debugMessage('send data', j);
        var messageArray = prepareSysExPacket(j, buffer, packetSize, fileLength, lastPacket, type,
                                                                msg0, msg1, msg2, modelNum, channel);

		setTimeout(sendMIDI.bind(null, id, messageArray,j, lastPacket), 2*j); // add a delay for each packet
    }
	debugMessage('send data', 'FINISHED');
}


function sendDataOverMIDIDirect(id, buffer,  fileLength)
{
    //if (buffer == NULL)
   //     return 0;
  
     //   ui->progressBarMidi->setMinimum(0);
    //    ui->progressBarMidi->setMaximum(fileLength);

      //  QThread* th = new QThread;

		var k = 0;
        for (var j = 0; j < fileLength; )
        {
            //QVector<quint8> message;
            var i;
            var packetSize = 0;
            var message = [];
            for (i = 0; i < fileLength; i++)
            {
                if (i + j >= fileLength)
                    break;
                var c = buffer[i + j];

                message.push(c);
               // qDebug() << "byte: " << (quint8) c << " i + j: " << i + j;
                if (c == 0xF7) // if is end of packet
                {
               // 	debugMessage( "END packet: " + (i + j));
               //     qDebug() << i + j << "END packet";
                    break;
                }
                packetSize++;
            }
            j += i + 1;
            k++;
            
            
            
            setTimeout(sendMIDI.bind(null, id, message, j, fileLength), 3*k); // add a delay for each packet
            
      /*      
            std::vector<unsigned char> m = message.toStdVector();
            countDownTimerMIDIOut = 6;
            this->midiOut->sendMessage( &m );
            ui->progressBarMidi->setValue(j+1);
            QCoreApplication::processEvents(QEventLoop::ExcludeUserInputEvents);
            th->usleep((ui->spinBoxMIDIdelay->value() * packetSize) / 32);*/
        }
        return 1;

}


function prepareSysExPacket(j,  buffer,  packetSize,  fileLength, lastPacket,  type,  msg0, msg1,  msg2, modelNum,  channel )
{
	var array = [BYTE_SYSEX_START];
	array.push(BYTE_SYSEX_ID1);
	array.push(BYTE_SYSEX_ID2);
	array.push(BYTE_SYSEX_ID3);
	array.push(modelNum);
	array.push(channel & 0x0F);
	array.push(0x00);
	array.push(type);

    if (j == 0)
        array.push(MIDI_SYSEX_START_TRANSFER)
    else if (j == lastPacket - 1)
    {
        array.push(MIDI_SYSEX_END_TRANSFER)
    }
    else
	{
        array.push(MIDI_SYSEX_CONTINUE_TRANSFER)
	}

    if (j == 0)
    {
        array.push(msg0 & 0x7F);
        array.push(msg1 & 0x7F);
        array.push(msg2 & 0x7F);
    }
    for (var i = 0 ; i < packetSize; i++)
    {
        var index = i + j * packetSize;
        if (index >= fileLength)
            break;
		var view = new DataView(buffer);
        array.push(view.getUint8(index));
    }

    array.push(BYTE_SYSEX_END);
	return array;
}

function requestScreenshot(id, modelNum, channel)
{
	
	//debugMessage('screenshot', 'request');
	if (screenShotUpdated)
	{
		sendMIDISysExCommand(id, modelNum, channel, MIDI_SYSEX_REQUEST_BITMAP, 0);
		screenShotUpdated = false;
	}
}

function functionRequestScreenShot()
{
    //debugMessage('MIDI data', 'request screenshot');
	if (document.getElementById('checkBoxRequestScreenshot').checked) 
	{   
		
		var modelNum = Number(document.getElementById("motasModel").value);
		var channel = document.getElementById("midiChannel").value - 1;

		var id = getMIDIOutId();
		screenShotFunctionRefreshId = setInterval(requestScreenshot.bind(null, id, modelNum, channel), 50); // call repeatedly
	} else
	{
		
		clearInterval(screenShotFunctionRefreshId);
		screenShotUpdated = true;
	}
}

